package com.lsw.controller;

import com.jfinal.core.Controller;
import com.jfinal.kit.JsonKit;
import com.jfinal.kit.Kv;
import com.jfinal.plugin.activerecord.Db;
import com.jfinal.plugin.activerecord.Record;
import com.lsw.utils.StringUtil;
import com.lsw.utils.TimeUtil;

import java.util.List;
import java.util.stream.Collectors;

public class ReportController extends Controller {

    public void index() {
        String op = getPara("op", "finish");
        String ID = getPara("ID", "ZMMMGm5mnGCE4WvWFeI");//部门ID
        set("url", "http://192.168.0.251/obpm/portal/good/html/view.html?appId=__gAPYBW4YxB3UePM3lqO&viewId=__qTB1jbQVLUOib2npaBj&opentarget=target&containTitle=%E8%A7%86%E5%9B%BE");
        set("begin", "2021-06-01");//TimeUtil.getDay("firstDay")
        set("end", "2022-12-12");//TimeUtil.getDay("lastDay")
        set("DOMAINID", getPara("DOMAINID", "uumsxrgm1KEEqSZIoHs"));
        set("ID", ID);
        List<Record> department_list = Db.template("department", Kv.by("ID", ID)).find();
        List<Record> list = department_list.stream().filter(r -> r.get("ID").equals(ID)).collect(Collectors.toList());
        for (Record record : list) {
            set("value",record.getStr("ID"));
            //二级
            List<Record> list2 = department_list.stream().filter(r -> r.get("SUPERIOR") != null && r.get("SUPERIOR").equals(record.get("ID"))).collect(Collectors.toList());
            record.set("children", list2);
            for (Record record2 : list2) {
                //三级
                List<Record> list3 = department_list.stream().filter(r -> r.get("SUPERIOR") != null && r.get("SUPERIOR").equals(record2.get("ID"))).collect(Collectors.toList());
                record2.set("children", list3);
                for (Record record3 : list3) {
                    //三级
                    List<Record> list4 = department_list.stream().filter(r -> r.get("SUPERIOR") != null && r.get("SUPERIOR").equals(record3.get("ID"))).collect(Collectors.toList());
                    record3.set("children", list4);
                }
            }

        }
        set("department", JsonKit.toJson(list));
        render(op + ".html");
    }

    //实验完成率
    public void finish() {
        long start = System.currentTimeMillis();
        Kv kv = Kv.create();
        kv.set("DOMAINID", getPara("DOMAINID"));
        kv.set("ID", getPara("ID"));
        kv.set("begin", getPara("begin", TimeUtil.getDay("firstDay")));
        kv.set("end", getPara("end", TimeUtil.getDay("lastDay")));
        List<Record> list = Db.template("finish", kv).find();
        long end = System.currentTimeMillis();
        renderJson(Kv.by("data", list).set("time", StringUtil.mul((end - start), (float) 0.001) + "s"));
    }

    //各流程耗时
    public void process() {
        long start = System.currentTimeMillis();
        Kv kv = Kv.create();
        kv.set("DOMAINID", getPara("DOMAINID"));
        kv.set("ID", getPara("ID"));
        kv.set("begin", getPara("begin", TimeUtil.getDay("firstDay")));
        kv.set("end", getPara("end", TimeUtil.getDay("lastDay")));
        List<Record> list = Db.template("process", kv).find();
        long end = System.currentTimeMillis();
        renderJson(Kv.by("data", list).set("time", StringUtil.mul((end - start), (float) 0.001) + "s"));
    }
}